//    !    
//         .
//    

//       ,    

#include<stdio.h>
#include<stdlib.h>
#include<memory.h>

#define SIZE 50000	//!<  

struct node_st{node_st *p,*p1,*p2; int value;}; //!<  
node_st array[SIZE];	//!<   


//!  
void Install()
{
	int n;
	memset(array,0,sizeof(array));
	for(n=0; n<SIZE; n++) {
		array[n].value=1+rand()%100; 
		if(!n) continue;
		for(;;) {
			int d=rand()&1;
			int m=rand()%n;
			if(d==0 && !array[m].p1) {array[m].p1=&array[n],array[n].p=&array[m]; break;}
			if(d==1 && !array[m].p2) {array[m].p2=&array[n],array[n].p=&array[m]; break;}
		}
	}
}

//!   ( S12)
//! \retval vector      
void TestWalk(node_st *node,int vector[SIZE],int &index)
{
	if(!node) return;
	if(index>SIZE) return;	// 
	vector[index++]=node->value;      // S
	TestWalk(node->p1,vector,index);  // 1
	TestWalk(node->p2,vector,index);  // 2
}

//!      (   ).
//!  1S2  -   ,   ,   
enum DIR{D_S12,D_1S2,D_12S};

//!   !!!
//! \param dir   
//! \param node  
//! \retval vector      
void Walk(DIR dir,node_st *node,int vector[SIZE])
{
	enum State{P1,P2,P}state=P1;
	int index=0;
	for(;;){
		if(index>SIZE) return;	// 
		switch(state) {
		case P1: 
			if(dir==D_S12) vector[index++]=node->value;
			if(node->p1) node=node->p1,state=P1;
			else state=P2;
			break;
		case P2: 
			if(dir==D_1S2) vector[index++]=node->value;
			if(node->p2) node=node->p2,state=P1;
			else state=P;
			break;
		case P:
			if(dir==D_12S) vector[index++]=node->value;
			if(node->p) {
				if(node->p->p1==node) state=P2;
				else state=P;
				node=node->p;
			} else return;
			break;
		}
	}
}

//  
int vector1[SIZE+1],vector2[SIZE+1];

void main()
{
	
	Install();
	memset(vector1,0,sizeof(vector1));
	memset(vector2,0,sizeof(vector2));
	int index=0; 
	Walk(D_S12,&array[0],vector2);		// 
	TestWalk(&array[0],vector1,index);	//  
	if(memcmp(vector1,vector2,sizeof(vector1))) printf("Internal error\n\a");
	else printf("Ok. (count=%d)\n",index);
	system("pause");
}

